#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct UpdateModuleRequest {
    #[builder(into)]
    #[serde(rename = "title")]
    title: String,
    #[builder(into)]
    #[serde(rename = "description")]
    description: String,
    #[builder(custom(type = super::ModuleVersionDefinition, convert = Box::new))]
    #[serde(rename = "definition")]
    definition: Box<super::ModuleVersionDefinition>,
}
impl UpdateModuleRequest {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        title: impl Into<String>,
        description: impl Into<String>,
        definition: super::ModuleVersionDefinition,
    ) -> Self {
        Self::builder()
            .title(title)
            .description(description)
            .definition(definition)
            .build()
    }
    #[inline]
    pub fn title(&self) -> &str {
        &*self.title
    }
    #[inline]
    pub fn description(&self) -> &str {
        &*self.description
    }
    #[inline]
    pub fn definition(&self) -> &super::ModuleVersionDefinition {
        &*self.definition
    }
}
